<template>
<div class="math-game">

  <div class="math-game-container">

    <div class="problem-container">

      <div class="problem-container__top">
        {{ time }}
      </div>

      <div class="problem-container__middle">
        {{ problemString }}
      </div>

      <div class="problem-container__bottom">
        {{ problemCount }} / {{ numberOfProblems }}
      </div>
    </div>

    <div class="solution-container">

      <ul class="solution-container__solutions">
        <li class="solution-container__solution"
            v-for="(s, i) in solutions"
            :key="i"
            :data-col="i + 1"
            @click=onClickSolution($event)>
          {{ s }}
        </li>
      </ul>

      <ul class="solution-container__fails">
        <li class="solution-container__fail"
            v-for="(f, i) in fails"
            :key="i"
            :data-index="i">
          {{ f.solution }}
        </li>
      </ul>
    </div>
  </div>
</div>
</template>

<script>
import _ from 'lodash';

import generateMath from '../js/generate-math';
import getRandomNumber from '../js/get-random-number';
import Vue from 'vue';

export default {
  name: 'MathGame',

  data () {
    return {
      handlingInput: false,
      numberOfProblems: 20,
      problemCount: 0,
      problemSet: null,
      solutions: [],
      fails: [],
      nextRows: {
        col1: 1,
        col2: 1,
        col3: 1,
        col4: 1
      },
      maxRowHeight: 10,
      timeLimit: 5,
      time: 0,
      timer: null,
      solutionFound: false
    };
  },

  computed: {
    problemString () {
      return generateMath.getProblemString(this.problemSet);
    }
  },

  methods: {
    getProblemSet () {
      return generateMath.getProblemSet(generateMath.getRandomOperation());
    },
    getOffsetNumber (num, offset) {
      const op = getRandomNumber(1, 2);
      if (op === 1) {
        return num + offset;
      }
      else {
        return num - offset;
      }
    },
    generateSolutions () {
      let solutions = [this.problemSet.solution];

      for (let i = 0; i < 3; i++) {
        let offset;
        let fake;

        switch (this.problemSet.operation) {
          case '+':
          case '-':
            do {
              offset = getRandomNumber(1, 5);
              fake = this.getOffsetNumber(this.problemSet.solution, offset);
            } while (solutions.find(s => s === fake));
            solutions.push(fake);
            break;

          case '*':
            do {
              let multiplier = getRandomNumber(1, 2);

              const op = getRandomNumber(1, 2);
              if (op === 1) {
                fake =
                  this.problemSet.operands[0] *
                  this.problemSet.operands[1] +
                  (this.problemSet.operands[0] * multiplier);
              }
              else {
                fake =
                  this.problemSet.operands[0] *
                  this.problemSet.operands[1] +
                  (this.problemSet.operands[1] * multiplier);
              }
            } while (solutions.find(s => s === fake));
            solutions.push(fake);
            break;

          default:
            break;
        }
      }

      return _.shuffle(solutions);
    },
    nextProblem () {
      this.solutionFound = false;

      do {
        this.problemSet = this.getProblemSet();
      } while (this.problemSet.operation === '/');
      this.solutions = this.generateSolutions();

      this.startTimer();
    },
    async onClickSolution (e) {
      if (this.handlingInput) {
        return;
      }

      this.handlingInput = true;

      const el = e.target;
      const solution = this.solutions[el.dataset.col - 1];
      if (solution === this.problemSet.solution) {
        await this.handleGoodSolution(el);
      }
      else {
        await this.handleBadSolution(el, solution);
      }

      this.handlingInput = false;
    },
    async startTimer () {
      this.time = this.timeLimit;

      while (this.time > 0) {
        await this.tickTimer();
        if (this.solutionFound) {
          return;
        }
      }

      if (!this.solutionFound) {
        this.timesUp();
      }
    },
    async tickTimer () {
      return new Promise(resolve => {
        this.timer = setTimeout(() => {
          this.time--;
          resolve();
        }, 1000);
      });
    },
    async timesUp () {
      this.handlingInput = true;
      clearTimeout(this.timer);

      const solutionEls =
        document.querySelectorAll('.solution-container__solution');

      for (let i = 0; i < solutionEls.length; i++) {
        const solutionEl = solutionEls[i];
        if (
          !solutionEl.hasAttribute('disabled') &&
          solutionEl.dataset.correct !== 1
        ) {
          const solution = this.solutions[solutionEl.dataset.col - 1];
          await this.handleBadSolution(solutionEl, solution);
        }
      };

      setTimeout(() => {
        this.handlingInput = false;
        this.endTurn();
      }, 1000);
    },
    async handleGoodSolution (el) {
      clearTimeout(this.timer);
      el.solutionFound = true;
      el.dataset.correct = 1;
      this.problemCount++;

      return new Promise(resolve => {
        setTimeout(() => {
          if (this.isWin()) {
            return this.$emit('game-over', true);
          }

          this.endTurn();
          this.handlingInput = false;
          resolve();
        }, 1000);
      });
    },
    async handleBadSolution (el, solution) {
      el.setAttribute('disabled', 'disabled');

      const col = el.dataset.col;
      const row = this.nextRows[`col${el.dataset.col}`];
      this.nextRows[`col${el.dataset.col}`]++;

      this.fails.push({
        solution,
        col,
        row
      });

      await Vue.nextTick();

      const selector =
        `.solution-container__fail[data-index="${this.fails.length - 1}"]`;
      const failEl = document.querySelector(selector);
      failEl.dataset.col = col;
      failEl.dataset.row = row;

      if (this.isLose()) {
        return this.$emit('game-over', false);
      }
    },
    isLose () {
      for (const key in this.nextRows) {
        if (this.nextRows.hasOwnProperty(key)) {
          const val = this.nextRows[key] - 1;
          if (val >= this.maxRowHeight) {
            return true;
          }
        }
      }
    },
    isWin () {
      return this.problemCount === this.numberOfProblems;
    },
    endTurn () {
      const solutionEls =
        document.querySelectorAll('.solution-container__solution');

      solutionEls.forEach(solutionEl => {
        if (solutionEl.hasAttribute('disabled')) {
          solutionEl.removeAttribute('disabled');
        }
        solutionEl.dataset.correct = 0;
      });

      this.nextProblem();
    }
  },

  created () {
    this.nextProblem();
  }
};
</script>

<style lang="scss" scoped>
@import '../scss/colors';
@import '../scss/utils';

.math-game-container {
  @extend %game-container;

  display: grid;
  grid-template-columns: 1fr 1fr;
}

.problem-container {
  display: grid;
  grid-template-rows: calc(75vh / 11) 4fr 1fr;
}

.problem-container__top,
.problem-container__middle,
.problem-container__bottom {
  display: flex;
  justify-content: center;
  align-items: center;
}

.problem-container__top {
  border-bottom: 1px solid $white-dark;

  color: $white;
}

.problem-container__middle {
  border-bottom: 1px solid $white-dark;

  color: $green;
  font-size: 8vw;
  text-decoration: underline;

  @media screen and (min-width: 426px) {
    font-size: 2.1em;
  }

  @media screen and (min-width: 769px) {
    font-size: 4.2em;
  }
}

.problem-container__bottom {
  color: $white-dark;
  font-size: 4vw;

  @media screen and (min-width: 426px) {
    font-size: 1.1em;
  }

  @media screen and (min-width: 769px) {
    font-size: 2.2em;
  }
}

.solution-container {
  display: grid;
  grid-template-rows: calc(75vh / 11) calc(75vh - (75vh / 11));

  border: 1px solid $white;
}

.solution-container__solutions,
.solution-container__fails {
  display: grid;
  grid-template-columns: repeat(4, 1fr);

  width: 100%;
  margin: 0;
  padding: 0;

  list-style: none;
}

.solution-container__fails {
  grid-template-rows: repeat(10, 1fr);
}

.solution-container__solution,
.solution-container__fail {
  justify-self: center;
  align-self: center;

  display: flex;
  justify-content: center;
  align-items: center;

  width: 100%;
  height: 100%;
}

.solution-container__solution {
  cursor: pointer;

  border: 1px solid $white;
  border-left-color: $white-dark;
  border-bottom-color: $white-dark;

  background-color: $black-light;

  &:hover {
    background-color: lighten($black-light, 10%);
  }

  &:active {
    background-color: darken($green, 40%);
  }

  &[disabled] {
    // -webkit-animation: solution-drop 500ms forwards; /* Safari 4+ */
    // -moz-animation:    solution-drop 500ms forwards; /* Fx 5+ */
    // -o-animation:      solution-drop 500ms forwards; /* Opera 12+ */
    animation:         solution-drop 500ms forwards; /* IE 10+, Fx 29+ */
  }

  &[data-correct='1'] {
    animation:         solution-correct 1s; /* IE 10+, Fx 29+ */
  }
}

.solution-container__fail {
  // border: 1px solid $white-dark;

  background-color: $red-dark;

  &[data-col='1'] {
    grid-column: 1 / 2;
  }

  &[data-col='2'] {
    grid-column: 2 / 3;
  }

  &[data-col='3'] {
    grid-column: 3 / 4;
  }

  &[data-col='4'] {
    grid-column: 4 / 5;
  }

  &[data-row='1'] {
    grid-row: -1 / -2;

    border-bottom: 1px solid $white;
  }

  &[data-row='2'] {
    grid-row: -2 / -3;
  }

  &[data-row='3'] {
    grid-row: -3 / -4;
  }

  &[data-row='4'] {
    grid-row: -4 / -5;
  }

  &[data-row='5'] {
    grid-row: -5 / -6;
  }

  &[data-row='6'] {
    grid-row: -6 / -7;
  }

  &[data-row='7'] {
    grid-row: -7 / -8;
  }

  &[data-row='8'] {
    grid-row: -8 / -9;
  }

  &[data-row='9'] {
    grid-row: -9 / -10;
  }

  &[data-row='10'] {
    grid-row: -10 / -11;
  }

  animation:         solution-fail 1s; /* IE 10+, Fx 29+ */
}

// Keyframes

@keyframes solution-drop {
  to {
    transform: translateY(75vh);
    cursor: default;
    opacity: 0;
  }
}

@keyframes solution-correct {
  0% {
    background-color: #252525;
  }
  50% {
    background-color: $green;
  }
  100% {
    background-color: #252525;
  }
}

@keyframes solution-fail {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
</style>
